---
apiVersion: apiextensions.k8s.io/v1
kind: CustomResourceDefinition
metadata:
  annotations:
    controller-gen.kubebuilder.io/version: v0.17.0
  name: openstackrouters.openstack.k-orc.cloud
spec:
  group: openstack.k-orc.cloud
  names:
    kind: OpenStackRouter
    listKind: OpenStackRouterList
    plural: openstackrouters
    singular: openstackrouter
  scope: Namespaced
  versions:
  - additionalPrinterColumns:
    - jsonPath: .status.conditions[?(@.type=="Ready")].status
      name: Ready
      type: string
    - jsonPath: .status.conditions[?(@.type=="Error")].status
      name: Error
      type: string
    - jsonPath: .status.conditions[?(@.type=="Ready")].message
      name: Status
      type: string
    - jsonPath: .status.resource.id
      name: OpenStackID
      type: string
    name: v1alpha1
    schema:
      openAPIV3Schema:
        description: OpenStackRouter is the Schema for the openstackrouters API
        properties:
          apiVersion:
            description: |-
              APIVersion defines the versioned schema of this representation of an object.
              Servers should convert recognized schemas to the latest internal value, and
              may reject unrecognized values.
              More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
            type: string
          kind:
            description: |-
              Kind is a string value representing the REST resource this object represents.
              Servers may infer this from the endpoint the client submits requests to.
              Cannot be updated.
              In CamelCase.
              More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
            type: string
          metadata:
            type: object
          spec:
            description: OpenStackRouterSpec defines the desired state of OpenStackPort
            properties:
              cloud:
                description: Cloud is the OpenStackCloud hosting this resource
                type: string
              id:
                description: |-
                  ID is the UUID of the existing OpenStack resource to be adopted. If
                  left empty, the controller will create a new resource using the
                  information in the "resource" stanza.
                type: string
              resource:
                description: OpenStackRouterSpec defines the desired state of OpenStackRouter
                properties:
                  adminStateUp:
                    description: AdminStateUp is the administrative state of the router.
                    type: boolean
                  availabilityZoneHints:
                    description: |-
                      Availability zone hints groups router nodes.
                      Used to make router resources highly available.
                    items:
                      type: string
                    type: array
                  description:
                    type: string
                  distributed:
                    description: Distributed is whether router is distributed or not.
                    type: boolean
                  externalGatewayInfo:
                    description: |-
                      OpenStackRouterSpecExternalGateway represents the information of an external gateway for any
                      particular network router.
                    properties:
                      enableSNAT:
                        type: boolean
                      externalFixedIps:
                        items:
                          description: |-
                            OpenStackRouterExternalFixedIP is the IP address and subnet of the external gateway of a
                            router.
                          properties:
                            ipAddress:
                              type: string
                            subnet:
                              type: string
                          type: object
                        type: array
                      network:
                        type: string
                    type: object
                  name:
                    description: Name of the OpenStack resource.
                    type: string
                  ports:
                    description: All the ports that will be added as router interfaces
                    items:
                      type: string
                    type: array
                  projectID:
                    description: ProjectID is the project owner of the router.
                    type: string
                  tenantID:
                    description: |-
                      TenantID is the project owner of the router. Only admin users can
                      specify a project identifier other than its own.
                    type: string
                type: object
              unmanaged:
                description: |-
                  Unmanaged, when true, means that no action will be performed in
                  OpenStack against this resource.
                type: boolean
            required:
            - cloud
            type: object
          status:
            description: OpenStackRouterStatus defines the observed state of OpenStackPort
            properties:
              conditions:
                description: |-
                  Represents the observations of an OpenStack resource's current state.
                  All resources must define: "Ready", "WaitingFor", "Error"
                items:
                  description: Condition contains details for one aspect of the current
                    state of this API Resource.
                  properties:
                    lastTransitionTime:
                      description: |-
                        lastTransitionTime is the last time the condition transitioned from one status to another.
                        This should be when the underlying condition changed.  If that is not known, then using the time when the API field changed is acceptable.
                      format: date-time
                      type: string
                    message:
                      description: |-
                        message is a human readable message indicating details about the transition.
                        This may be an empty string.
                      maxLength: 32768
                      type: string
                    observedGeneration:
                      description: |-
                        observedGeneration represents the .metadata.generation that the condition was set based upon.
                        For instance, if .metadata.generation is currently 12, but the .status.conditions[x].observedGeneration is 9, the condition is out of date
                        with respect to the current state of the instance.
                      format: int64
                      minimum: 0
                      type: integer
                    reason:
                      description: |-
                        reason contains a programmatic identifier indicating the reason for the condition's last transition.
                        Producers of specific condition types may define expected values and meanings for this field,
                        and whether the values are considered a guaranteed API.
                        The value should be a CamelCase string.
                        This field may not be empty.
                      maxLength: 1024
                      minLength: 1
                      pattern: ^[A-Za-z]([A-Za-z0-9_,:]*[A-Za-z0-9_])?$
                      type: string
                    status:
                      description: status of the condition, one of True, False, Unknown.
                      enum:
                      - "True"
                      - "False"
                      - Unknown
                      type: string
                    type:
                      description: type of condition in CamelCase or in foo.example.com/CamelCase.
                      maxLength: 316
                      pattern: ^([a-z0-9]([-a-z0-9]*[a-z0-9])?(\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*/)?(([A-Za-z0-9][-A-Za-z0-9_.]*)?[A-Za-z0-9])$
                      type: string
                  required:
                  - lastTransitionTime
                  - message
                  - reason
                  - status
                  - type
                  type: object
                type: array
                x-kubernetes-list-map-keys:
                - type
                x-kubernetes-list-type: map
              resource:
                description: OpenStackRouterStatus defines the observed state of OpenStackRouter
                properties:
                  ID:
                    description: ID is the unique identifier for the router.
                    type: string
                  adminStateUp:
                    description: AdminStateUp is the administrative state of the router.
                    type: boolean
                  availabilityZoneHints:
                    description: |-
                      Availability zone hints groups network nodes that run services like DHCP, L3, FW, and others.
                      Used to make network resources highly available.
                    items:
                      type: string
                    type: array
                  description:
                    description: Description for the router.
                    type: string
                  distributed:
                    description: Distributed is whether router is disitrubted or not.
                    type: boolean
                  externalGatewayInfo:
                    description: GatewayInfo provides information on external gateway
                      for the router.
                    properties:
                      enableSNAT:
                        type: boolean
                      externalFixedIps:
                        items:
                          description: |-
                            OpenStackRouterExternalFixedIP is the IP address and subnet of the external gateway of a
                            router.
                          properties:
                            ipAddress:
                              type: string
                            subnet:
                              type: string
                          type: object
                        type: array
                      networkID:
                        type: string
                    type: object
                  name:
                    description: |-
                      Name is the human readable name for the router. It does not have to be
                      unique.
                    type: string
                  ports:
                    description: Ports provides information on the interfaces connected
                      to this router
                    items:
                      type: string
                    type: array
                  projectID:
                    description: ProjectID is the project owner of the router.
                    type: string
                  routes:
                    description: Routes are a collection of static routes that the
                      router will host.
                    items:
                      description: OpenStackRouterRoute is a possible route in a router.
                      properties:
                        destination:
                          type: string
                        nextHop:
                          type: string
                      required:
                      - destination
                      - nextHop
                      type: object
                    type: array
                  status:
                    description: Status indicates whether or not a router is currently
                      operational.
                    type: string
                  tags:
                    description: Tags optionally set via extensions/attributestags
                    items:
                      type: string
                    type: array
                  tenantID:
                    description: |-
                      TenantID is the project owner of the router. Only admin users can
                      specify a project identifier other than its own.
                    type: string
                type: object
            type: object
        type: object
    served: true
    storage: true
    subresources:
      status: {}
